﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="custom-button-in-radwindow-titlebar.aspx.cs" Inherits="custom_button_in_radwindow_titlebar" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <style type="text/css">
        /* classic render mode */
        div.RadWindow .rwControlButtons li a.customprintbutton {
            background: url(classic-sprite.png) no-repeat;
        }

            div.RadWindow .rwControlButtons li a.customprintbutton:hover {
                background: url(classic-sprite.png) 0 -20px no-repeat;
            }

        /* lightweight render mode */
        /* Tip: you can also use font icons as of Q3 2015 */

        /*for XHTML 1.0 Transitional doctype only, uncomment if you use it*/
        .RadWindow .rwListItem {
            vertical-align: top;
        }
        div.RadWindow .rwCommandButton::before {
            width: 1em;
            height: 1em;
        }
        /*end of xhtml 1.0 transitional fix*/

        div.RadWindow .rwCommands span.customprintbutton {
            background: url(lightweight-sprite.png) no-repeat;
        }

            div.RadWindow .rwCommands span.customprintbutton:hover {
                background: url(lightweight-sprite.png) 0 -20px no-repeat;
            }

        /* If you will be using custom font icons, tweak this accordingly */
        div.RadWindow .rwCommandButton.customprintbutton::before {
            content: ""; /* this is where you can set your own custom font icon. You will also need to set the appropriate font name */
        }
    </style>
</head>
<body>
    <form id="form1" runat="server">
        <asp:ScriptManager ID="Scriptmanager1" runat="server" />
        <asp:RadioButtonList ID="RadioButtonList1" runat="server" AutoPostBack="true">
            <asp:ListItem Text="Lightweight" Selected="true" />
            <asp:ListItem Text="Classic" />
        </asp:RadioButtonList>
        <telerik:RadWindow ID="RadWindow1" runat="server" VisibleOnPageLoad="true" OnClientShow="OnClientShow"
            NavigateUrl="Dialog.aspx">
        </telerik:RadWindow>
        <script type="text/javascript">
            function OnClientShow(sender, args) {
                var TitleBar = sender.GetTitlebar();
                var parent = TitleBar.parentNode;
                var oUL = parent.getElementsByTagName('UL')[0];
                if (!(oUL.firstChild.id == "customprintbuttonID")) // Check if the element is already added 
                {
                    // If not - create and add the custom button 
                    var oLI = document.createElement("LI");
                    oLI.id = "customprintbuttonID"

                    //create the actual button
                    var customBtn;
                    //set the proper custom button class for decoration
                    var customBtnClass = "customprintbutton";
                    //choose the handler for the button
                    var desiredHandler = printWin;

                    switch (sender._renderMode) {
                        case Telerik.Web.UI.RenderMode.Lite: {//lightweight
                            customBtn = document.createElement("span");
                            customBtn.className = "rwCommandButton ";
                            oLI.className = "rwListItem";
                            break;
                        }
                        case Telerik.Web.UI.RenderMode.Classic: {//classic
                            customBtn = document.createElement("a");
                            customBtn.href = "javascript:void(0)";
                            //if the titlebar does not appear OK you may need to tweak its width
                            //see at the end of the function for another possible workaround you can uncomment
                            //oUL.style.width = "192px";
                            break;
                        }
                        default: {
                            if (console && console.log)
                                console.log("Unknown render mode. Examine the HTML to see what elements to use");
                        }
                    }

                    customBtn.className = customBtn.className + customBtnClass;
                    customBtn.title = "Print Content";

                    //add the required handler for your custom functionality
                    if (Telerik.Web.UI.EventType) { //Q3 2015 versions and later - modern IE versions supported (e.g., Edge, 11)
                        var NS = ".wndCustomButton";
                        var DOWN_NS = Telerik.Web.UI.EventType.Down + NS;
                        $telerik.$(customBtn).onEvent(DOWN_NS, desiredHandler);
                    }
                    else { //old Telerik.Web.UI (pre Q2 2015)
                        customBtn.onmousedown = desiredHandler;
                    }

                    //add the custom button to the RadWindow
                    oLI.appendChild(customBtn);
                    oUL.insertBefore(oLI, oUL.firstChild);

                    //if RadWindow does not display its titlebar properly after being modified, uncomment this code:
                    //most likely, will be necessary for the Classic Render Mode
                    //sender._updateTitleWidth();
                }
            }

            //a sample handler for the custom titlebar button
            function printWin(e) {
                var oWnd = $find("<%=RadWindow1.ClientID%>");
                var content = oWnd.GetContentFrame().contentWindow;
                var printDocument = content.document;
                if (document.all) {
                    printDocument.execCommand("Print");
                } else {
                    content.print();
                }
                //Cancel event
                if (!e)
                    e = window.event;

                return $telerik.cancelRawEvent(e);
            }
        </script>
    </form>
</body>
</html>
